#include "timer.h"

volatile uint32_t debug_timerTick;//ʱͳʹ  
extern   uint32_t systemcoreclock;

void TIMER_Init(void)
{
  /* ʹTMR2ʱ */
  crm_periph_clock_enable(CRM_TMR2_PERIPH_CLOCK, TRUE);
  crm_periph_clock_enable(CRM_TMR3_PERIPH_CLOCK, TRUE);
  crm_periph_clock_enable(CRM_TMR4_PERIPH_CLOCK, TRUE);
  crm_periph_clock_enable(CRM_TMR5_PERIPH_CLOCK, TRUE);
  
  /* ʼTMR2 */
  tmr_base_init(TMR2, systemcoreclock/10000, 10);
  tmr_cnt_dir_set(TMR2, TMR_COUNT_UP);

  
  tmr_interrupt_enable(TMR2, TMR_OVF_INT, TRUE);
  
  nvic_irq_enable(TMR2_GLOBAL_IRQn, 2, 0);
  
  /* ʼTMR3 */
  tmr_base_init(TMR3, systemcoreclock/11000, 100);
  tmr_cnt_dir_set(TMR3, TMR_COUNT_UP);

  
  tmr_interrupt_enable(TMR3, TMR_OVF_INT, TRUE);
  
  nvic_irq_enable(TMR3_GLOBAL_IRQn, 2, 0);
  
  /* ʼTMR4 */
  tmr_base_init(TMR4, systemcoreclock/10000, 100);
  tmr_cnt_dir_set(TMR4, TMR_COUNT_UP);

  
  tmr_interrupt_enable(TMR4, TMR_OVF_INT, TRUE);
  
  nvic_irq_enable(TMR4_GLOBAL_IRQn, 7, 0);
  
  /* ʼTMR5 */
  tmr_base_init(TMR5, systemcoreclock/10000, 20000);
  tmr_cnt_dir_set(TMR5, TMR_COUNT_UP);
  
  /* ʹTMR2 */
  tmr_counter_enable(TMR2, TRUE);
  tmr_counter_enable(TMR3, TRUE);
  tmr_counter_enable(TMR4, TRUE);
  tmr_counter_enable(TMR5, TRUE);
}

void TMR2_GLOBAL_IRQHandler(void)
{
  if(tmr_flag_get(TMR2, TMR_OVF_FLAG) != RESET)
  {
    debug_timerTick++;
    tmr_flag_clear(TMR2, TMR_OVF_FLAG);
  }
}

void TMR3_GLOBAL_IRQHandler(void)
{
  if(tmr_flag_get(TMR3,TMR_OVF_FLAG)!= RESET)
  {
    printf("TMR3 IRQ\r\n");
    tmr_flag_clear(TMR3,TMR_OVF_FLAG);
  }
}

void TMR4_GLOBAL_IRQHandler(void)
{
  if(tmr_flag_get(TMR4,TMR_OVF_FLAG)!= RESET)
  {
    printf("TMR4 IRQ\r\n");
    tmr_flag_clear(TMR4,TMR_OVF_FLAG);
  }
}











